using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace XmlProviders.Data
{
    /// <summary>
    /// 
    /// </summary>
    [Serializable()]
    public class Role
    {
        private string _name;
        private List<string> _usernames;

        /// <summary>
        /// Initializes a new instance of the <see cref="Role"/> class.
        /// </summary>
        public Role()
        {
            _usernames = new List<string>();
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        [XmlAttribute("name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        /// <summary>
        /// Gets the users.
        /// </summary>
        /// <value>The users.</value>
        [XmlElement("user")]
        public Collection<string> Users
        {
            get { return new Collection<string>(_usernames); }
        }
    }
}
