Ext.onReady(function(){

    var tree = new Ext.tree.TreePanel({
        title: 'West Region',
        region:'west',
        split:true,
        width:200,
        margins:'5 0 5 5',
        collapsible:true,
        rootVisible: false
    });

    var root = new Ext.tree.TreeNode({
        text: 'Root Node',
        expanded: true
    });
    tree.setRootNode(root);

    root.appendChild(new Ext.tree.TreeNode({text: 'Item 1'}));
    root.appendChild(new Ext.tree.TreeNode({text: 'Item 2'}));
    root.appendChild(new Ext.tree.TreeNode({text: 'Item 3'}));
    
    tree.on('click', function(n){
		Ext.Msg.prompt('Edit Paragraph', 
			'<b>Current value:</b><br />' + n.text, 
			function(btn, text){
			if(text != '' && btn == 'ok'){
				n.setText(text);
				Ext.fly(n.getUI().getTextEl()).highlight();
			}
		}, this, true);
    });

    var viewport = new Ext.Viewport({
        layout: 'border',
        items: [
            tree, {
            border: false,
            region:'center',
            margins:'5 5 5 0',
            layout:'border',
            items: [{
                title: 'Center "Fill" Region with Inner Border Layout',
                region: 'center',
                html: '<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Sed metus nibh, sodales a, porta at, vulputate eget, dui. Pellentesque ut nisl.</p>'
            },{
                region: 'south',
                split: 'true',
                height: 200,
                html: '<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Sed metus nibh, sodales a, porta at, vulputate eget, dui. Pellentesque ut nisl.</p>'
            }]
        }]
    });
});