
    	Ext.BLANK_IMAGE_URL = '../resources/images/default/s.gif';
        Ext.onReady(function(){
			Ext.QuickTips.init();
			var tree = new Ext.tree.TreePanel({
				region: 'west',
				width: 200,
				split: true,
				title: 'Categories',
				collapsible: true
			});
			
			var root = new Ext.tree.TreeNode({
			    text: 'Categories',
				expanded: true
			});
			tree.setRootNode(root);
			
			root.appendChild(new Ext.tree.TreeNode({text: 'Widgets'}));
			root.appendChild(new Ext.tree.TreeNode({text: 'Utilities'}));
			root.appendChild(new Ext.tree.TreeNode({text: 'Toys'}));			
			
			var grid = new Ext.grid.GridPanel({
				title: 'Product Inventory',
				store: new Ext.data.SimpleStore({
					fields: [
						'productSku',
						'price', 
						{name: 'expires', type: 'date', dateFormat: 'm-d-Y'}
					],
					data: [
						['A0015', 101.25, '09-01-2007'],
						['C0084', 29.01, '09-02-2007'],
						['H0016', 83.81, '09-05-2007']
					]
				}),
				columns: [{
					dataIndex: 'productSku',
					header: 'Product SKU'
				},{
					dataIndex: 'price',
					header: 'Price',
					renderer: Ext.util.Format.usMoney
				},{
					dataIndex: 'expires',
					header: 'Expires',
					renderer: Ext.util.Format.dateRenderer('m/d/Y')
				}],
				viewConfig: {
					forceFit: true
				}
			});			
			
			var form = new Ext.FormPanel({
			    title: 'New Product',
			    labelWidth: 75,
			    border:false,
				bodyStyle: 'padding: 10px;',
			    defaultType: 'textfield',
			    items: [{
			        fieldLabel: 'Product SKU',
			        name: 'sku',
			        allowBlank:false
			    },{
			        fieldLabel: 'Price',
			        name: 'price'
			    }, 
			        new Ext.form.DateField({
			            fieldLabel: 'Expires',
			            name: 'expires'
			        })
			    ],
			    buttons: [{
			        text: 'Save'
			    },{
			        text: 'Cancel'
			    }]
			});			
			
			var tabs = new Ext.TabPanel({
			    border:false,
			    resizeTabs:true,
			    enableTabScroll:true,
			    activeItem:0,
			    defaults:{
			        autoScroll:true
			    },
			    items:[grid,form]
			});			
			
            var vp = new Ext.Viewport({
				layout: 'border',
				items: [{
					title: 'categories',
					region: 'west',
					layout:'fit',
					width: 200,
					items: [tree]
				},{
					region: 'center',
					title: 'Content',
					layout: 'fit',
					items: [tabs]
				},{
					region: 'south',
					title: 'South',
					height: 150,
					collapsible: true,
					collapsed: true
				}]
			});
        });