﻿<%@ WebHandler Language="C#" Class="Users" %>

using System;
using System.Collections.Generic;
using System.Web;
using App_Code;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

public class Users : IHttpHandler
{

    public void ProcessRequest(HttpContext context)
    {

        int start = 0;
        int limit = Int32.MaxValue;
        
        if (HttpContext.Current.Request["start"] != null)
        {
            start = Convert.ToInt32(HttpContext.Current.Request["start"]);
        }

        if (HttpContext.Current.Request["limit"] != null)
        {
            limit = Convert.ToInt32(HttpContext.Current.Request["limit"]);
        }

        var userQuery = new UserQuery
                            {
                                Start = start,
                                Limit = limit
                            };
        
        context.Response.ContentType = "text/plain";
        var userManager = new UserManager();
        List<UserResult> listUsers = userManager.Get(userQuery);

        
       
        var o = new
                       {
                           total = userQuery.TotalCount,
                           success = true,
                           rows = listUsers
                       };
        string retString = o.ToJson();
        HttpContext.Current.Response.Write(retString);
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}